var currentTabPane;
var settingsUI = function() {
    var items = [
        [
            {el: {type: 'llabel', value: '数据库地址'}},
            {el: {type: 'text', widgetName: 'db_url'}}
        ],
        [
            {el: {type: 'llabel', value:'用户名'}},
            {el: {type: 'text', widgetName: 'db_username'}}
        ],
        [
            {el: {type: 'llabel', value: '密码'}},
            {el: {type: 'password', widgetName: 'db_password', value : '******'}}
        ]
    ];
    var rowSize = [21, 21, 21];
    var height = 160;
    var basicTablelayout = {
        widgetName: 'db_tablelayout',
        type: 'tablelayout',
        items: items,
        columnSize: [131, 450],
        rowSize: rowSize,
        vgap: 20
    };
    return {
        title: '数据库',
        content: {
            widgetName: 'db_setting_pane',
            type: 'confirm',
            firstBtnMargin: 0,
            text4OK: FR.i18nText("FS-Frame-Simple_Save"),
            text4Cancel: null,
            width: 650,
            height: height,
            btnsAlignment: 'left',
            closeAfterAction: false,
            doSize: true,
            onOK: function () {
                save();
            },
            contentWidget: basicTablelayout
        }
    };
};
var save = function() {
    var db_url = currentTabPane.getWidgetByName('db_url').getValue();
    var db_user = currentTabPane.getWidgetByName('db_username').getValue();
    var db_password = currentTabPane.getWidgetByName('db_password').getValue();
    FR.ajax({
        url : FR.servletURL + '?op=fs_load_addon&cmd=db_settings_save',
        data : {
            'db_url' : db_url,
            'db_user' : db_user,
            'db_password' : db_password
        },
        complete : function(res, status) {
            if (status === 'success') {
                var info = FR.jsonDecode(res.responseText);
                if (info.status === 'success') {
                    FR.Msg.toast("数据库修改成功");
                } else {
                    FR.Msg.alert("错误", info.msg);
                }
            }
        }
    });
};
FS.Plugin.SystemItems.push({

    ui : settingsUI,

    pop : function(idx, tabPane) {
        currentTabPane = tabPane;
        FR.ajax({
            url : FR.servletURL + '?op=fs_load_addon&cmd=get_db_info',
            complete : function(res, status) {
                var r = FR.jsonDecode(res.responseText);
                tabPane.getWidgetByName("db_url").setValue(r.url);
                tabPane.getWidgetByName("db_username").setValue(r.user);
            }
        });
    }
});